$(document).ready(function(){
	var temp_layer;
	$('.preview-card').on('click', function(ev, form) {
		var active_form, selected_img, category_select,
			category_idx = 0;

		if (!form)
			form = $(this).parents('form');

		category_select = form.find('select#greeting_card_record_category_id');

		// form maybe not the same as active_form when multiple category exist
		if (category_select.length != 0)
		{
			var selected_option = category_select.find('option:selected');
			active_form = $('form#' + selected_option.prop('value'));
			category_idx = selected_option.index();
		}
		else
		{
			active_form = $('.greeting_card_form');
		}

		selected_img = active_form.find('.card_images_wrapper input:checked').siblings('img');

		if (selected_img.length == 0)
			return false;

		var img_url = selected_img.attr('src');
		if (img_url)
		{
			var layer;
			var data = {};
			var fields = collected_fields[category_idx];
			var objs = card_img_objs[category_idx];
			fields.forEach(function(f) {
				var field_input = active_form.find("#greeting_card_record_" + f);
				data[f] = field_input.val();
			});
			if (temp_layer)
			{
				destroy_layer(temp_layer);
			}
			layer = create_konva(active_form.find(".preview-card-section"), 'card-container', img_url, data);
			window.layer = layer;
			objs.forEach(function(obj) {
				create_text_box(layer,
								{x: obj.x, y: obj.y, w: obj.w, h: obj.h, l_h: obj.l_h},
								obj.text,
								obj.fontSize, obj.fontFamily, obj.fontColor,
								(obj.is_stroke == 'true'), obj.stroke, obj.strokeWidth,
								(obj.is_fill == 'true'));
			});
			fields.forEach(function(f) {
				var field_input = active_form.find("#greeting_card_record_" + f);
				field_input.on("input", function() {
					layer.container.trigger("change", [f, $(this).val()]);
				})
			});

			active_form.find("input[name=\"greeting_card_record[card_id]\"]").on("change", function() {
				layer.container_img.attr('src', $(this).siblings('img').attr('src'));
			})

			temp_layer = layer;
		}
	});
	$('select#greeting_card_record_category_id').on('change', function() {
		if (temp_layer)
		{
			var form = $(this).parents('form');
			form.find('.preview-card').trigger('click', [form]);
		}
	})
})