Array.prototype.removeItem = function(v) {
  function removeValue(value, index, arr) {
      // If the value at the current array index matches the specified value (2)
      if (value === v) {
      // Removes the value from the original array
          arr.splice(index, 1);
          return true;
      }
      return false;
  }

  // Pass the removeValue function into the filter function to return the specified value
  return this.filter(removeValue)[0];
};

if (!(String.prototype.replaceAll))
{
  String.prototype.replaceAll = function (FindText,RepText) {
    regExp = new RegExp(FindText, "g");

    return this.replace(regExp,RepText);
  }
}

function apply_scale(layer, box)
{
  box.x( box.org_x * layer.w_scale );
  box.y( box.org_y * layer.h_scale );
  if (box.org_w != 'auto')
    box.width( box.org_w * layer.w_scale );
  if (box.org_h != 'auto')
    box.height( box.org_h * layer.h_scale );
  box.fontSize( box.org_fontSize * layer.font_scale);
  box.strokeWidth( box._strokeWidth * layer.font_scale);
  box.scaled = true;
}

function create_konva(container_wrapper, container_id, img_url, data)
{
  var container_inner_wrapper = $("<div id=\"container-inner-wrapper\"></div>")
  var container_img = $("<img id=\"container-img\" src=\"" + img_url + "\" />");
  var container = $("<div id=\"" + container_id + "\"></div>");
  var layer = new Konva.Layer({draggable: false});
  container_inner_wrapper.appendTo(container_wrapper).append(container_img).append(container);

  layer.font_scale = null;
  layer.w_scale    = null;
  layer.h_scale    = null;

  container_img.on("load", function(){
    var img_width = container_img.outerWidth(true),
        img_height = container_img.outerHeight(true);

    var stage = new Konva.Stage({
      container: container_id,
      width: img_width,
      height: img_height
    });
    // add canvas element
    layer.font_scale = img_width / 500;
    layer.img_width = img_width;
    layer.img_height = img_height;
    layer.w_scale = img_width / 100;
    layer.h_scale = img_height / 100;


    layer.text_boxes.forEach(function(box) {
      if (box.scaled)
        return;
      else
      {
        apply_scale(layer, box);
      }
    });
    layer.pending_boxes.forEach(function(args) {
      args[0] = layer;
      create_text_box.apply(null, args);
    });

    layer.pending_boxes = [];
    
    stage.add(layer);
  });

  layer.container_inner_wrapper = container_inner_wrapper;
  layer.container = container;
  layer.container_img = container_img;
  layer.data = data;

  layer.text_boxes = [];
  layer.pending_boxes = [];

  layer.resize_func = function(container_img) {
    var img_width, img_height;
    var stage = this.getStage();
    if (this.resized)
    {
      window.setTimeout(function(){
        this.resize_func(container_img);
      }.bind(this), 100);
      return;
    }
    this.resized = true;
    stage.setWidth();
    stage.setHeight();
    img_width = container_img.outerWidth(true);
    img_height = container_img.outerHeight(true);
    stage.setWidth(img_width);
    stage.setHeight(img_height);
    this.font_scale = img_width / 500;
    this.w_scale = img_width / 100;
    this.h_scale = img_height / 100;
    this.img_width = img_width;
    this.img_height = img_height;

    this.pending_boxes = [null];

    this.text_boxes.forEach(function(box) {
      apply_scale(this, box);
    }.bind(this));

    this.pending_boxes = [];

    this.resized = false;
  }.bind(layer, container_img);

  $(window).on("resize", layer.resize_func);

  return layer;
}

function create_text_box(layer, pos, text, fontSize, fontFamily, fontColor, is_stroke, stroke, strokeWidth, is_fill)
{
  if (!layer)
    return;

  if (!layer.font_scale || !layer.w_scale || !layer.h_scale)
  {
    layer.pending_boxes.push(arguments);
    return;
  }
  else if (layer.pending_boxes.length != 0)
  {
    var args = arguments;
    window.setTimeout(function(args){
      create_text_box.apply(this, args);
    }.bind(this, args), 100);
    return;
  }

  var scaled = false;
  var org_fontSize = fontSize,
      org_x = pos.x,
      org_y = pos.y,
      x, y, w, h,
      org_w, org_h,
      org_text = text,
      _strokeWidth,
      observe_fields = [],
      observe_func;
  if (!fontFamily)
    fontFamily = 'Calibri';

  if (!fontColor)
    fontColor = '#333333';

  if (!stroke)
    stroke = '#333333';

  if (!strokeWidth)
    strokeWidth = 2;

  _strokeWidth = strokeWidth;

  org_w = (pos.w == 0 ? 'auto' : pos.w);
  org_h = (pos.h == 0 ? 'auto' : pos.h);
  x = pos.x;
  y = pos.y;
  w = org_w;
  h = org_h;

  text = org_text.replace(/{([^{}]+)}/g, function(_, f) {
    observe_fields.push(f);
    return layer.data[f];
  });

  if (layer.font_scale && layer.w_scale && layer.h_scale)
  {
    x = pos.x * layer.w_scale;
    y = pos.y * layer.h_scale;
    if (w != 'auto')
      w *= layer.w_scale;
    if (h != 'auto')
      h *= layer.h_scale;
    fontSize *= layer.font_scale;
    strokeWidth *= layer.font_scale;
    scaled = true;
  }

  if (!is_stroke)
    is_fill = true;

  // create shape
  var textNode = new Konva.Text({
    text: text,
    width: w,
    height: h,
    x: x,
    y: y,
    lineHeight: pos.l_h,
    fontSize: fontSize,
    draggable: true,
    fontFamily: fontFamily,
    stroke: (is_stroke ? stroke : null),
    strokeWidth: (is_stroke ? strokeWidth : null),
    fillAfterStrokeEnabled: true
  });
  textNode.fill((is_fill ? fontColor : false));
  layer.add(textNode);

  textNode._fill = fontColor;
  textNode.scaled = scaled;
  textNode.org_fontSize = org_fontSize;
  textNode.org_x = org_x;
  textNode.org_y = org_y;
  textNode.org_w = org_w;
  textNode.org_h = org_h;
  textNode.org_text = org_text;
  textNode.is_stroke = is_stroke;
  textNode.is_fill = is_fill;
  textNode._stroke = stroke;
  textNode._strokeWidth = _strokeWidth;
  textNode.observe_fields = observe_fields;

  if (observe_fields.length != 0) {
    observe_func = function(layer, event, f, content) {
      if ($.inArray(f, this.observe_fields) != -1)
      {
        var new_text;
        if (this.prev_change == f)
        {
          new_text = this.cached_text;
        }
        else
        {
          var other_fields = Array.from(this.observe_fields);
          other_fields.removeItem(f);
          new_text = this.org_text;
          other_fields.forEach(function(ff) {
            new_text = new_text.replaceAll('{' + ff + '}', layer.data[ff]);
          })
          this.cached_text = new_text;
          this.prev_change = f;
        }

        layer.data[f] = content;

        new_text = new_text.replaceAll('{' + f + '}', content);
        
        this.text(new_text);
      }
    }.bind(textNode, layer);
    textNode.observe_func = observe_func;
    layer.container.on("change", observe_func);
  }

  layer.text_boxes.push(textNode);

  return textNode;
}

function destroy_text(textNode)
{
  if (textNode.observe_func)
    layer.container.off("change", textNode.observe_func);
  textNode.destroy();
}

function destroy_layer(layer)
{
  layer.text_boxes.forEach(function(textNode) {
    destroy_text(textNode);
  });
  $(window).off("resize", layer.resize_func);
  layer.destroy();
  layer.container_inner_wrapper.remove();
}