Rails.application.routes.draw do
	locales = Site.first.in_use_locales rescue I18n.available_locales
	scope "(:locale)", locale: Regexp.new(locales.join("|")) do
		namespace :admin do #backend
			resources :greeting_cards do
				collection do
					delete 'delete'
					post 'batch_modify_status'
					get ':id/print', to: 'greeting_cards#print' 
					get 'export'
					get 'setting'
					get 'backend_table_setting'
					get 'category_setting'
					post 'get_category_setting_partial'
					post 'get_category_setting_field'
					post 'category_setting_save'
					get 'category_setting_delete'
					post 'switch_to_default_setting'
					get 'get_new_category_setting_index'
					get 'layout_design'
					get 'ticket_status'
					post 'get_ticket_status'
					post 'update_ticket_status'
					delete 'delete_ticket_status'
					post 'layout_design_save'
					post 'setting_save'
					post 'greeting_card_list_setting_save'
					post 'get_new_setting_index'
					post 'get_new_category_setting_index'
					post 'export', to: 'greeting_cards#do_export'
					get 'order_fields'
					post 'update_order_fields'
					post 'apply_default_custom_fields'
				end
			end
			resources :greeting_card_acknowledgements
			resources :greeting_card_admins
		end
		resources :greeting_cards #fronted
		get "/xhr/greeting_cards/verify_email/:id" => "greeting_cards#verify_email"
	end
end

